diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index d9df13fac..6bc6a97b5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.gui.achievements;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.ItemElement;
 import net.minecraft.client.gui.Screen;
@@ -10,11 +9,19 @@ import net.minecraft.client.gui.achievements.data.AchievementPageRegistry;
 import net.minecraft.client.gui.achievements.data.AchievementPages;
 import net.minecraft.client.gui.options.OptionsButtonElement;
 import net.minecraft.client.render.Lighting;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.CompareFunc;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.RenderBuffer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.achievement.stat.StatsCounter;
 import net.minecraft.core.item.Item;
@@ -27,20 +34,13 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.lwjgl.opengl.GL41;
 
 import java.util.Objects;
 import java.util.Random;
 
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
-import static org.lwjgl.opengl.GL11.glDisable;
-import static org.lwjgl.opengl.GL11.glEnable;
-
 public class ScreenAchievements extends Screen
 {
-
-
     private static final int TOP_SPACING = 24;
     private static final int BUTTON_SPACING = 4;
     private static final int SEPARATOR_WIDTH = 8;
@@ -106,53 +106,53 @@ public class ScreenAchievements extends Screen
 
     public ScreenAchievements(Screen parent, StatsCounter statsCounter)
     {
-        mouseXOld = 0;
-        mouseYOld = 0;
-        draggingViewport = false;
+        this.mouseXOld = 0;
+        this.mouseYOld = 0;
+        this.draggingViewport = false;
         this.statsCounter = statsCounter;
 
         this.parent = parent;
-        this.tooltip = new TooltipElement(mc);
-        this.renderItem = new ItemElement(mc);
+        this.tooltip = new TooltipElement(this.mc);
+        this.renderItem = new ItemElement(this.mc);
 
-        layers = new BGLayer[currentPage.backgroundLayers()];
-        for (int i = 0; i < layers.length; i++) {
-            layers[i] = new BGLayer(i);
+        this.layers = new BGLayer[this.currentPage.backgroundLayers()];
+        for (int i = 0; i < this.layers.length; i++) {
+            this.layers[i] = new BGLayer(i);
         }
     }
 
     @Override
 	public void init()
     {
-        buttons.clear();
-        buttons.add(new OptionsButtonElement(1, width / 2 - 100, height - 20 - BUTTON_SPACING, 200, 20, I18n.getInstance().translateKey("gui.achievements.button.done")));
+        this.buttons.clear();
+        this.buttons.add(new OptionsButtonElement(1, this.width / 2 - 100, this.height - 20 - BUTTON_SPACING, 200, 20, I18n.getInstance().translateKey("gui.achievements.button.done")));
 
-        lastTileX = Integer.MIN_VALUE;
-        lastTileY = Integer.MIN_VALUE;
+        this.lastTileX = Integer.MIN_VALUE;
+        this.lastTileY = Integer.MIN_VALUE;
 
-        top = TOP_SPACING;
-        bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
+        this.top = TOP_SPACING;
+        this.bottom = this.height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
 
-        pagesListScrollRegionHeight = bottom - top;
-        pageListLeft = 0;
-        pageListRight = width/4;
+        this.pagesListScrollRegionHeight = this.bottom - this.top;
+        this.pageListLeft = 0;
+        this.pageListRight = this.width /4;
 
-        viewportZoom = 1;
+        this.viewportZoom = 1;
 
-        viewportLeft = drawSidebar() ? pageListRight + SEPARATOR_WIDTH : 0;
-        viewportTop = top;
-        viewportBottom = bottom;
-        viewportRight = width;
+        this.viewportLeft = drawSidebar() ? this.pageListRight + SEPARATOR_WIDTH : 0;
+        this.viewportTop = this.top;
+        this.viewportBottom = this.bottom;
+        this.viewportRight = this.width;
 
-        viewportWidth = viewportRight - viewportLeft;
-        viewportHeight = viewportBottom - viewportTop;
+        this.viewportWidth = this.viewportRight - this.viewportLeft;
+        this.viewportHeight = this.viewportBottom - this.viewportTop;
 
         int achMinX = Integer.MAX_VALUE;
         int achMinY = Integer.MAX_VALUE;
         int achMaxX = Integer.MIN_VALUE;
         int achMaxY = Integer.MIN_VALUE;
 
-        for (AchievementPage.AchievementEntry ach : currentPage.getAchievementEntries()){
+        for (AchievementPage.AchievementEntry ach : this.currentPage.getAchievementEntries()){
             if (ach.x < achMinX){
                 achMinX = ach.x;
             }
@@ -167,26 +167,38 @@ public class ScreenAchievements extends Screen
             }
         }
 
-        shiftMinX = achMinX * ACHIEVEMENT_CELL_WIDTH ;
-        shiftMinY = achMinY * ACHIEVEMENT_CELL_HEIGHT;
-        shiftMaxX = achMaxX * ACHIEVEMENT_CELL_WIDTH  + ACHIEVEMENT_CELL_WIDTH;
-        shiftMaxY = achMaxY * ACHIEVEMENT_CELL_HEIGHT + ACHIEVEMENT_CELL_HEIGHT;
+        this.shiftMinX = achMinX * ACHIEVEMENT_CELL_WIDTH ;
+        this.shiftMinY = achMinY * ACHIEVEMENT_CELL_HEIGHT;
+        this.shiftMaxX = achMaxX * ACHIEVEMENT_CELL_WIDTH  + ACHIEVEMENT_CELL_WIDTH;
+        this.shiftMaxY = achMaxY * ACHIEVEMENT_CELL_HEIGHT + ACHIEVEMENT_CELL_HEIGHT;
 
-        shiftMinX -= (int) (viewportWidth /4d);
-        shiftMinY -= (int) (viewportHeight/4d);
-        shiftMaxX += (int) (viewportWidth /4d);
-        shiftMaxY += (int) (viewportHeight/4d);
+        this.shiftMinX -= (int) (this.viewportWidth /4d);
+        this.shiftMinY -= (int) (this.viewportHeight /4d);
+        this.shiftMaxX += (int) (this.viewportWidth /4d);
+        this.shiftMaxY += (int) (this.viewportHeight /4d);
 
         // Centers the screen on the Open ContainerInventory achievement
-        AchievementPage.AchievementEntry ach = currentPage.onOpenAchievement();
-        oldShiftX = targetShiftX = currentShiftX = ach.x * ACHIEVEMENT_CELL_WIDTH + ACHIEVEMENT_CELL_WIDTH/2d;
-        oldShiftY = targetShiftY = currentShiftY = ach.y * ACHIEVEMENT_CELL_HEIGHT + ACHIEVEMENT_CELL_HEIGHT/2d;
+        AchievementPage.AchievementEntry ach = this.currentPage.onOpenAchievement();
+        this.oldShiftX = this.targetShiftX = this.currentShiftX = ach.x * ACHIEVEMENT_CELL_WIDTH + ACHIEVEMENT_CELL_WIDTH/2d;
+        this.oldShiftY = this.targetShiftY = this.currentShiftY = ach.y * ACHIEVEMENT_CELL_HEIGHT + ACHIEVEMENT_CELL_HEIGHT/2d;
+    }
+
+    @Override
+    public void removed() {
+        if (this.lastBackgroundShadowBuf != null) {
+            this.lastBackgroundShadowBuf.delete();
+            this.lastBackgroundShadowBuf = null;
+        }
+        if (this.lastBackgroundTileBuf != null) {
+            this.lastBackgroundTileBuf.delete();
+            this.lastBackgroundTileBuf = null;
+        }
     }
 
     @Override
 	protected void buttonClicked(@NotNull ButtonElement button) {
         if(button.id == 1) {
-            mc.displayScreen(parent);
+            this.mc.displayScreen(this.parent);
             //mc.setIngameFocus();
         }
         super.buttonClicked(button);
@@ -196,27 +208,37 @@ public class ScreenAchievements extends Screen
 	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
         if (eventKey == Keyboard.KEY_ESCAPE) {
-            mc.displayScreen(parent);
+            this.mc.displayScreen(this.parent);
         } else {
             super.keyPressed(eventCharacter, eventKey, mx, my);
         }
     }
     @Override
     public void mouseClicked(int mx, int my, int buttonNum) {
-        if (drawSidebar() && mx >= pageListLeft && mx <= (pageListRight - 6) && my >= top && my <= bottom) {
+        if (drawSidebar() && mx >= this.pageListLeft && mx <= (this.pageListRight - 6) && my >= this.top && my <= this.bottom) {
             int pagesListHeight = getTotalPagesListHeight();
-            int pagesListY = top - (int) pageListScrollAmount;
-            if (pagesListHeight < bottom - top) {
-                pagesListY = top + (bottom - top - pagesListHeight) / 2;
+            int pagesListY = this.top - (int) this.pageListScrollAmount;
+            if (pagesListHeight < this.bottom - this.top) {
+                pagesListY = this.top + (this.bottom - this.top - pagesListHeight) / 2;
             }
             for(AchievementPage page : AchievementPageRegistry.getInstance().getPages()) {
-                if (mx >= pageListLeft && mx <= (pageListRight - 6) && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
-                    currentPage = page;
-                    mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                if (mx >= this.pageListLeft && mx <= (this.pageListRight - 6) && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
+                    this.currentPage = page;
+
+                    if (this.lastBackgroundShadowBuf != null) {
+                        this.lastBackgroundShadowBuf.delete();
+                        this.lastBackgroundShadowBuf = null;
+                    }
+                    if (this.lastBackgroundTileBuf != null) {
+                        this.lastBackgroundTileBuf.delete();
+                        this.lastBackgroundTileBuf = null;
+                    }
+
+                    this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
 
-                    layers = new BGLayer[currentPage.backgroundLayers()];
-                    for (int i = 0; i < layers.length; i++) {
-                        layers[i] = new BGLayer(i);
+                    this.layers = new BGLayer[this.currentPage.backgroundLayers()];
+                    for (int i = 0; i < this.layers.length; i++) {
+                        this.layers[i] = new BGLayer(i);
                     }
 
                     init();
@@ -227,66 +249,66 @@ public class ScreenAchievements extends Screen
         }
         super.mouseClicked(mx, my, buttonNum);
 
-        clickX = mx;
-        clickY = my;
+        this.clickX = mx;
+        this.clickY = my;
     }
 
     @Override
 	public void render(int mx, int my, float partialTick)
     {
         if(Mouse.isButtonDown(0)) {
-            if(mx >= viewportLeft && mx < viewportRight && my >= viewportTop && my < viewportBottom) {
-                if(!draggingViewport) {
-                    draggingViewport = true;
+            if(mx >= this.viewportLeft && mx < this.viewportRight && my >= this.viewportTop && my < this.viewportBottom) {
+                if(!this.draggingViewport) {
+                    this.draggingViewport = true;
                 } else {
-                    targetShiftX -= (mx - mouseXOld) / viewportZoom;
-                    targetShiftY -= (my - mouseYOld) / viewportZoom;
-                    currentShiftX = oldShiftX = targetShiftX;
-                    currentShiftY = oldShiftY = targetShiftY;
+                    this.targetShiftX -= (mx - this.mouseXOld) / this.viewportZoom;
+                    this.targetShiftY -= (my - this.mouseYOld) / this.viewportZoom;
+                    this.currentShiftX = this.oldShiftX = this.targetShiftX;
+                    this.currentShiftY = this.oldShiftY = this.targetShiftY;
                 }
-                mouseXOld = mx;
-                mouseYOld = my;
-            }
-            currentShiftX =  MathHelper.clamp(currentShiftX, shiftMinX, shiftMaxX);
-            currentShiftY =  MathHelper.clamp(currentShiftY, shiftMinY, shiftMaxY);
-        } else if (mc.controllerInput != null) {
-            targetShiftX += mc.controllerInput.joyRight.getX() / viewportZoom * 4;
-            targetShiftY += mc.controllerInput.joyRight.getY() / viewportZoom * 4;
-            currentShiftX = oldShiftX = targetShiftX;
-            currentShiftY = oldShiftY = targetShiftY;
-            currentShiftX =  MathHelper.clamp(currentShiftX, shiftMinX, shiftMaxX);
-            currentShiftY =  MathHelper.clamp(currentShiftY, shiftMinY, shiftMaxY);
-
-            if (mc.controllerInput.buttonLeftTrigger.isPressed()) {
-                viewportZoom -= 0.01d;
-            } else if (mc.controllerInput.buttonRightTrigger.isPressed()) {
-                viewportZoom += 0.01f;
-            }
-            viewportZoom = MathHelper.clamp(viewportZoom, 0.5d, 2d);
+                this.mouseXOld = mx;
+                this.mouseYOld = my;
+            }
+            this.currentShiftX =  MathHelper.clamp(this.currentShiftX, this.shiftMinX, this.shiftMaxX);
+            this.currentShiftY =  MathHelper.clamp(this.currentShiftY, this.shiftMinY, this.shiftMaxY);
+        } else if (this.mc.controllerInput != null) {
+            this.targetShiftX += this.mc.controllerInput.joyRight.getX() / this.viewportZoom * 4;
+            this.targetShiftY += this.mc.controllerInput.joyRight.getY() / this.viewportZoom * 4;
+            this.currentShiftX = this.oldShiftX = this.targetShiftX;
+            this.currentShiftY = this.oldShiftY = this.targetShiftY;
+            this.currentShiftX =  MathHelper.clamp(this.currentShiftX, this.shiftMinX, this.shiftMaxX);
+            this.currentShiftY =  MathHelper.clamp(this.currentShiftY, this.shiftMinY, this.shiftMaxY);
+
+            if (this.mc.controllerInput.buttonLeftTrigger.isPressed()) {
+                this.viewportZoom -= 0.01d;
+            } else if (this.mc.controllerInput.buttonRightTrigger.isPressed()) {
+                this.viewportZoom += 0.01f;
+            }
+            this.viewportZoom = MathHelper.clamp(this.viewportZoom, 0.5d, 2d);
 
         } else {
-            clickX = clickY = null;
-            oldPagesListScrollAmount = null;
-            draggingViewport = false;
+            this.clickX = this.clickY = null;
+            this.oldPagesListScrollAmount = null;
+            this.draggingViewport = false;
         }
 
-        if (drawSidebar() && mx >= pageListLeft && mx <= pageListRight) {
+        if (drawSidebar() && mx >= this.pageListLeft && mx <= this.pageListRight) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 scrollPagesList(Mouse.getDWheel() / -0.01f);
             } else {
                 scrollPagesList(Mouse.getDWheel() / -0.05f);
             }
             onScrollPagesList();
-        } else if (mx >= viewportLeft && mx <= viewportRight && my >= viewportTop && my <= viewportBottom){
+        } else if (mx >= this.viewportLeft && mx <= this.viewportRight && my >= this.viewportTop && my <= this.viewportBottom){
             final double change = (Mouse.getDWheel()/10d);
-            viewportZoom = MathHelper.clamp(viewportZoom + change, 0.5d, 2);
+            this.viewportZoom = MathHelper.clamp(this.viewportZoom + change, 0.5d, 2);
 
             // Make zoom notch onto integer multiples
             if (change != 0) {
                 final double[] notches = new double[]{0.25, 0.5, 1, 2, 4};
                 for (double notch : notches){
-                    if (Math.abs(viewportZoom - notch) < 0.05){
-                        viewportZoom = notch;
+                    if (Math.abs(this.viewportZoom - notch) < 0.05){
+                        this.viewportZoom = notch;
                         break;
                     }
                 }
